Delimiter ;;
DROP FUNCTION IF EXISTS reportingTypeToSqlType ;;

CREATE FUNCTION `reportingTypeToSqlType`(attribute_key INT) RETURNS varchar(255) CHARSET latin1
    READS SQL DATA
BEGIN
  /*****************************************************************************
   * 
   * Copyright (C) Zenoss, Inc. 2013, all rights reserved.
   * 
   * This content is made available according to terms specified in
   * License.zenoss under the directory where your Zenoss product is installed.
   * 
   ****************************************************************************/

  SELECT a1.odb_attribute_type, a1.odb_attribute_length, a1.odb_attribute_name, c1.odb_class_name
  INTO @odb_attribute_type, @odb_attribute_length, @odb_attribute_name, @odb_class_name
  FROM odb_attribute a1
  INNER JOIN odb_class c1 ON a1.odb_class_key = c1.odb_class_key
  WHERE odb_attribute_key = attribute_key;

  SET @column_type = 'VARCHAR(255)';

  -- NOTE: 'int' and 'long' types are represented by BIGINT

  IF @odb_attribute_type = 'string' AND 
  	@odb_class_name = 'rrddata_source' AND NOT(
   	@odb_attribute_name = 'id' OR @odb_attribute_name = 'name' OR @odb_attribute_name = 'key' OR
	@odb_attribute_name LIKE '%\_name' OR @odb_attribute_name LIKE '%\_id' OR @odb_attribute_name LIKE '%\_key')
  THEN
	SET @column_type = 'TEXT';
  ELSEIF @odb_attribute_type = 'string' AND @odb_attribute_length < 1 THEN
    SET @column_type = 'VARCHAR(255)';
  ELSEIF @odb_attribute_type = 'string' THEN
    SET @column_type = CONCAT('VARCHAR(',
    	CONVERT(@odb_attribute_length USING latin1), ')');
  ELSEIF @odb_attribute_type = 'boolean' THEN
    SET @column_type = 'TINYINT(1)';
  ELSEIF @odb_attribute_type = 'int' THEN
    SET @column_type = 'BIGINT';
  ELSEIF @odb_attribute_type = 'float' THEN
    SET @column_type = 'DOUBLE';
  ELSEIF @odb_attribute_type = 'long' THEN
    SET @column_type = 'BIGINT';
  ELSEIF @odb_attribute_type = 'date' THEN
    SET @column_type = 'DATETIME';
  ELSEIF @odb_attribute_type = 'reference' THEN
    SET @column_type = 'INT(11) UNSIGNED';
  END IF;

  RETURN @column_type;

END ;;

Delimiter ;
